# -----------------------------------------------------------------------------
# From the book "Managing Enterprise Active Directory Services"
# ISBN: 0-672-32125-4
# Copyright (C) 2002 by Addison-Wesley
# Script by Robbie Allen
# 
# You have a royalty-free right to use, modify, reproduce and distribute
# this script (and/or any modified version) in any way you find useful,
# provided that you agree that Addison-Wesley or Robbie Allen has no
# warranty, obligations or liability for the script. If you modify
# the script, you must retain this copyright notice.
# -----------------------------------------------------------------------------
#
# Add jdoe user
$result = $ldap->add (
    dn   => 'cn=jdoe,cn=users,dc=xyz,dc=com',
    attr => [
     cn      => 'jdoe'',
     samaccountname    => 'jdoe',
     userprincipalname => 'jdoe@xyz.com',
     mail              => 'jdoe@xyz.com',
     telephoneNumber   => '911',
     objectclass       => ['user'],
    ],
);
die $result->error if $result->code;
# Modify attributes of jdoe
$result = $ldap->modify('cn=jdoe,cn=users,dc=xyz,dc=com',
    changes => [
     add     => [ sn => 'Doe' ], # populate sn attribute
     delete  => [ telephoneNumber => '911'], # remove '911' telephoneNumber entry
     replace => [ mail => 'John.Doe@xyz.com'], # change email address
    ]
);
die $result->error if $result->code;
# Delete jdoe
$result = $ldap->delete("cn=jdoe,cn=users,dc=xyz,dc=com");
die $result->error if $result->code;
