# -----------------------------------------------------------------------------
# From the book "Managing Enterprise Active Directory Services"
# ISBN: 0-672-32125-4
# Copyright (C) 2002 by Addison-Wesley
# Script by Robbie Allen
# 
# You have a royalty-free right to use, modify, reproduce and distribute
# this script (and/or any modified version) in any way you find useful,
# provided that you agree that Addison-Wesley or Robbie Allen has no
# warranty, obligations or liability for the script. If you modify
# the script, you must retain this copyright notice.
# -----------------------------------------------------------------------------
use Net::LDAP;
use Net::LDAP::Control;
use Net::LDAP::Constant qw( LDAP_CONTROL_SORTREQUEST );
$ldap = Net::LDAP->new('dc1.xyz.com')
    or die "Could not connect: $@";
$search = $ldap->bind('administrator@xyz.com', password => 'password');
die $search->error if $mesg->code
$sort = Net::LDAP::Control->new( LDAP_CONTROL_SORTREQUEST, order => 'cn');
$search = $ldap->search(
             base  => "cn=users,dc=xyz,dc=com",
             scope => "subtree",
             filter => "(&(objectClass=user)(objectCategory=Person))",
             control => [ $sort ] );
print $entry->get_value('cn'),"\n" foreach $entry $search->entries;
$ldap->unbind;
