'# -----------------------------------------------------------------------------
'# From the book "Managing Enterprise Active Directory Services"
'# ISBN: 0-672-32125-4
'# Copyright (C) 2002 by Addison-Wesley
'# Script by Robbie Allen
'# 
'# You have a royalty-free right to use, modify, reproduce and distribute
'# this script (and/or any modified version) in any way you find useful,
'# provided that you agree that Addison-Wesley or Robbie Allen has no
'# warranty, obligations or liability for the script. If you modify
'# the script, you must retain this copyright notice.
'# -----------------------------------------------------------------------------
Dim Obj as IADs
Dim SecurityDescriptor as IADsSecurityDescriptor
Dim ACE as AccessControlEntry
Dim DACL as AccessControlList
Set Obj = GetObject("LDAP://ou=Admins,dc=xyz,dc=com")
Set SecurityDescriptor = Obj.Get("ntSecurityDescriptor")
Set DACL = SecurityDescriptor.DiscretionaryACL
Set ACE = CreateObject("AccessControlEntry")
ACE.AccessMask = ADS_RIGHT_DELETE Or ADS_RIGHT_GENERIC_READ Or ADS_RIGHT_GENERIC_WRITE
ACE.AceFlags = ADS_ADSFLAG_NO_PROPOGATE_INHERIT_ACE
ACE.AceType = ADS_ACETYPE_ACCESS_ALLOWED
ACE.Trustee = "jdoe@xyz.com"
DACL.AddAce ACE
SecurityDescriptor.DiscretionaryACL = DACL
Obj.Put "ntSecurityDescriptor",Array(SecurityDescriptor)
Obj.SetInfo
