'# -----------------------------------------------------------------------------
'# From the book "Managing Enterprise Active Directory Services"
'# ISBN: 0-672-32125-4
'# Copyright (C) 2002 by Addison-Wesley
'# Script by Robbie Allen
'# 
'# You have a royalty-free right to use, modify, reproduce and distribute
'# this script (and/or any modified version) in any way you find useful,
'# provided that you agree that Addison-Wesley or Robbie Allen has no
'# warranty, obligations or liability for the script. If you modify
'# the script, you must retain this copyright notice.
'# -----------------------------------------------------------------------------
Dim user, passwd, server, system_cont, ldapObj, trustsObj, trustObj
Dim count, trustTypes, trustDirections

server = "dc1"
user   = "administrator@xyz.com"
passwd = "password"
system_cont = "cn=system,dc=xyz,dc=com"

trustTypes = Array("Unknown","Downlevel","Uplevel","Kerberos","DCE")
trustDirections = Array("Disabled","Trusting","Trusted","Trusting and Trusted")

Set ldapObj = GetObject("LDAP:")
Set trustsObj = ldapObj.OpenDsObject("LDAP://" & server & "/" & system_cont, _
                                       user, passwd, 1)
trustsObj.Filter = Array("trustedDomain")

Wscript.Echo "Trusts for " & server & ":"
count = 0
On Error Resume Next
For Each trustObj in trustsObj
   count = count + 1
   Wscript.Echo count & ". " & trustObj.trustPartner _
                      & " - " & trustTypes(trustObj.trusttype) _
                      & " " & trustDirections(trustObj.trustdirection)
Next
