'# -----------------------------------------------------------------------------
'# From the book "Managing Enterprise Active Directory Services"
'# ISBN: 0-672-32125-4
'# Copyright (C) 2002 by Addison-Wesley
'# Script by Robbie Allen
'# 
'# You have a royalty-free right to use, modify, reproduce and distribute
'# this script (and/or any modified version) in any way you find useful,
'# provided that you agree that Addison-Wesley or Robbie Allen has no
'# warranty, obligations or liability for the script. If you modify
'# the script, you must retain this copyright notice.
'# -----------------------------------------------------------------------------
Dim user, passwd, server, rootDSE, forestDN, domainDN, ldapObj
Dim pdcfsmo, ridfsmo, schemafsmo, infrafsmo, dnfsmo

' Authentication Information
user   = "administrator@xyz.com"
passwd = "password"
server = "dc1"

' Need to get domain's default naming context
Set rootDSE = GetObject("LDAP://" & server & "/RootDSE")
forestDN  = rootDSE.Get("rootDomainNamingContext")
domainDN  = rootDSE.Get("defaultNamingContext")

Set ldapObj = GetObject("LDAP:")

Wscript.Echo "FSMOs known by " & server & ":"

' PDC Emulator
Set pdcfsmo = ldapObj.OpenDsObject("LDAP://" & server & "/" & domainDN, _
                                   user, passwd, 1)
Wscript.Echo "PDC Emulator: " & pdcfsmo.fsmoroleowner

' RID Master
Set ridfsmo = ldapObj.OpenDsObject("LDAP://" & server & "/" _
                                  & "cn=RID Manager$,cn=system," _
                                  & domainDN, _
                                  user, passwd, 1)
Wscript.Echo "RID Master: " & ridfsmo.fsmoroleowner

' Schema Master
Set schemafsmo = ldapObj.OpenDsObject("LDAP://" & server & "/" _
                                  & "cn=Schema,cn=Configuration," _
                                  & forestDN, _
                                  user, passwd, 1)
Wscript.Echo "Schema Master: " & schemafsmo.fsmoroleowner

' Infrastructure Master
Set infrafsmo = ldapObj.OpenDsObject("LDAP://" & server & "/" _
                                  & "cn=Infrastructure," _
                                  & domainDN, _
                                  user, passwd, 1)
Wscript.Echo "Infrastructure Master: " & infrafsmo.fsmoroleowner

' Domain Naming Master
Set dnfsmo = ldapObj.OpenDsObject("LDAP://" & server & "/" _
                                  & "cn=Partitions,cn=Configuration," _
                                  & forestDN, _
                                  user, passwd, 1)
Wscript.Echo "Domain Naming Master: " & dnfsmo.fsmoroleowner
