# -----------------------------------------------------------------------------
# From the book "Managing Enterprise Active Directory Services"
# ISBN: 0-672-32125-4
# Copyright (C) 2002 by Addison-Wesley
# Script by Robbie Allen
# 
# You have a royalty-free right to use, modify, reproduce and distribute
# this script (and/or any modified version) in any way you find useful,
# provided that you agree that Addison-Wesley or Robbie Allen has no
# warranty, obligations or liability for the script. If you modify
# the script, you must retain this copyright notice.
# -----------------------------------------------------------------------------
use strict;
use Net::LDAP;

my $server  = 'dc1';
my $user    = 'administrator@xyz.com';
my $passwd  = 'password';

my $ldap = Net::LDAP->new($server)
            or die "Could not connect to $server";
my $bind = $ldap->bind($user, password => $passwd);
die "Could not bind to $server" if $bind->code;

# Connect to RootDSE
my $rootdse = $ldap->search(base   => '',
                            filter => '(objectclass=*)',
                            scope  => 'base');
# Transfer the PDC role
my $res = $rootdse->entry(0)->add( becomePDC => 1);
$res = $rootdse->entry(0)->update( $ldap );
if ($res->code) {
   print "Could not transfer FSMO: ",$res->error,"\n";
}
else {
   print "Successfully initiated FSMO transfer to $server\n";
}

$ldap->unbind;
