# -----------------------------------------------------------------------------
# From the book "Managing Enterprise Active Directory Services"
# ISBN: 0-672-32125-4
# Copyright (C) 2002 by Addison-Wesley
# Script by Robbie Allen
# 
# You have a royalty-free right to use, modify, reproduce and distribute
# this script (and/or any modified version) in any way you find useful,
# provided that you agree that Addison-Wesley or Robbie Allen has no
# warranty, obligations or liability for the script. If you modify
# the script, you must retain this copyright notice.
# -----------------------------------------------------------------------------
use strict;
use Net::DNS;

my $update = Net::DNS::Update->new("xyz.com.");
$update->push("pre", nxrrset("host1.xyz.com. A"));
$update->push("update", rr_add("host1.xyz.com. 5200 A 192.168.1.5"));

my $res = Net::DNS::Resolver->new;
$res->nameservers("dc1.xyz.com.");
my $reply = $res->send($update);

if ($reply) {
    if ($reply->header->rcode eq "NOERROR") {
        print "Update succeeded\n";
    }
    else {
        print "Update failed: ", $reply->header->rcode, "\n";
    }
}
else {
    print "Update failed: ", $res->errorstring, "\n";
}
