# -----------------------------------------------------------------------------
# From the book "Managing Enterprise Active Directory Services"
# ISBN: 0-672-32125-4
# Copyright (C) 2002 by Addison-Wesley
# Script by Robbie Allen
# 
# You have a royalty-free right to use, modify, reproduce and distribute
# this script (and/or any modified version) in any way you find useful,
# provided that you agree that Addison-Wesley or Robbie Allen has no
# warranty, obligations or liability for the script. If you modify
# the script, you must retain this copyright notice.
# -----------------------------------------------------------------------------
use strict;
use Net::DNS;

my $target = 'dc1.xyz.com';
my $res = Net::DNS::Resolver->new();
   $res->nameservers($target);
my $query = $res->search("127.in-addr.arpa", "NS");
if ($query) {
   foreach my $rr ($query->answer) {
      next unless $rr->type eq "NS";
      print "Received response: ",$rr->nsdname,"\n";
   }
}
else {
   die "NS query failed: ", $res->errorstring, "\n";
}
