# -----------------------------------------------------------------------------
# From the book "Managing Enterprise Active Directory Services"
# ISBN: 0-672-32125-4
# Copyright (C) 2002 by Addison-Wesley
# Script by Robbie Allen
# 
# You have a royalty-free right to use, modify, reproduce and distribute
# this script (and/or any modified version) in any way you find useful,
# provided that you agree that Addison-Wesley or Robbie Allen has no
# warranty, obligations or liability for the script. If you modify
# the script, you must retain this copyright notice.
# -----------------------------------------------------------------------------
use strict;
use Net::LDAP;

my $new_subnet = '10.4.2.0/24';
my $subnet_site = 'RTP';

# This could be dynamically retrieved using RootDSE
my $sites_dn = "cn=sites,cn=configuration,dc=xyz,dc=com";

my $server  = 'dc1.xyz.com';
my $user    = 'administrator@xyz.com';
my $passwd  = 'password';

my $ldap = Net::LDAP->new($server) or die "$@";
my $result = $ldap->bind($user, password => $passwd);
$result->code && die $result->error;
s
print "Creating subnet $new_subnet\n";
$result = $ldap->add (
             dn   => "cn=$new_subnet,cn=Subnets,$sites_dn",
             attr => [ objectclass => 'subnet',
                       siteObject  => "cn=$subnet_site,$sites_dn",
                     ]);
$result->code && die $result->error;
print "Subnet creation complete\n";
$ldap->unbind;
