VERSION 5.00
Begin VB.Form DsKCC 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "DsReplicaConsistencyCheck"
   ClientHeight    =   2550
   ClientLeft      =   45
   ClientTop       =   345
   ClientWidth     =   4590
   Icon            =   "Chap09_Listing18_DS_Replica_Consistency_Check_form.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2550
   ScaleWidth      =   4590
   StartUpPosition =   3  'Windows Default
   Begin VB.Frame Frame1 
      Height          =   2535
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   4575
      Begin VB.TextBox txtCopy 
         Height          =   285
         Left            =   3960
         TabIndex        =   4
         Top             =   2160
         Visible         =   0   'False
         Width           =   375
      End
      Begin VB.CommandButton cmdCopy 
         Caption         =   "C&opy"
         Height          =   375
         Left            =   2400
         TabIndex        =   3
         Top             =   2100
         Width           =   1095
      End
      Begin VB.CommandButton CmdCheck 
         Caption         =   "&Check"
         Height          =   375
         Left            =   960
         TabIndex        =   2
         Top             =   2100
         Width           =   1215
      End
      Begin VB.ListBox LstOutput 
         Height          =   1815
         Left            =   120
         TabIndex        =   1
         Top             =   240
         Width           =   4335
      End
   End
End
Attribute VB_Name = "DsKCC"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

Option Explicit
Option Base 0

' -----------------------------------------------------------------------------
' From the book "Managing Enterprise Active Directory Services"
' ISBN: 0-672-32125-4
' Copyright (C) 2002 by Addison-Wesley
' Code by Richard Puckett
'
' You have a royalty-free right to use, modify, reproduce and distribute
' this code (and/or any modified version) in any way you find useful,
' with the agreement that Richard Puckett or Addison-Wesley provide no
' warranty, obligations or liability for this code. If you reuse or
' modify this code, you must retain this copyright notice.
' -----------------------------------------------------------------------------

Private Const DS_KCC_TASKID_UPDATE_TOPOLOGY = 0&
Private Const DS_KCC_FLAG_ASYNC_OP = 1&

Private Declare Function DsReplicaConsistencyCheck Lib "Ntdsapi.dll" _
    (ByVal hDS As Long, _
    ByVal TaskID As Long, _
    ByVal dsFlags As Long) As Long

'DsBindWithCred takes two optional input parameters that identify whether the caller has already
'found a domain controller using the DsGetDcName function or whether a domain controller should be
'found using default parameters. Behavior of the possible combinations is outlined in the following list.

'Note: The DnsDomainName is required to secure a Kerberos authentication.
'- DomainController(NULL), DnsDomainName(NULL) DsBindWithCred attempts to bind to a global catalog and fail if one cannot be found.
'- DomainController(value), DnsDomainName(NULL) The value for DomainController is assumed to have been obtained
'using the DsGetDcName function, which returns this value in the DomainControllerName field of the DOMAIN_CONTROLLER_INFO
'structure. The client is bound to the domain controller at this address.
'- DomainController(NULL), DnsDomainName(value) DsBindWithCred attempts to find a domain controller for the domain
'identified by DnsDomainName and fails if one cannot be found.
'- DomainController(value), DnsDomainName(value) This is an illegal combination. The call will fail.

'DWORD DsMakePasswordCredentials(
'  LPTSTR User,
'  LPTSTR Domain,
'  LPTSTR Password,
'  RPC_AUTH_IDENTITY_HANDLE* pAuthIdentity
');

Private Declare Function DsMakePasswordCredentials Lib "Ntdsapi.dll" _
    Alias "DsMakePasswordCredentialsA" _
    (ByVal User As String, _
    ByVal Domain As String, _
    ByVal Password As String, _
    pAuthIdentity As Long) As Long

'DWORD DsBindWithCred(
'  TCHAR* DomainController,
'  TCHAR* DnsDomainName,
'  RPC_AUTH_IDENTITY_HANDLE AuthIdentity,
'  HANDLE* phDS
');
    
Private Declare Function DsBindWithCred Lib "Ntdsapi.dll" _
    Alias "DsBindWithCredA" _
    (ByVal DomainController As String, _
    ByVal DnsDomainName As String, _
    ByVal AuthIdentity As Long, _
    phDS As Long) As Long
    
'VOID DsFreePasswordCredentials(
'  RPC_AUTH_IDENTITY_HANDLE AuthIdentity
');

Private Declare Function DsFreePasswordCredentials Lib "Ntdsapi.dll" _
    (ByVal AuthIdentity As Long) As Long
    
'DWORD DsBind(
'  TCHAR* DomainController,
'  TCHAR* DnsDomainName,
'  HANDLE* phDS
');
    
Private Declare Function DsBind Lib "Ntdsapi.dll" _
    Alias "DsBindA" _
    (ByVal DomainController As String, _
    ByVal DnsDomainName As String, _
    phDS As Long) As Long
    
'DWORD DsUnBind(
'  HANDLE* phDS
');
    
Private Declare Function DsUnBind Lib "Ntdsapi.dll" _
    Alias "DsUnBindA" _
    (ByVal phDS As Long) As Long
   
Private Declare Sub MoveMemory Lib "kernel32.dll" _
    Alias "RtlMoveMemory" _
    (pDest As Any, _
    pSource As Any, _
    ByVal dwLength As Long)

Private Sub CmdCheck_Click()

    Dim lngRet As Long
    Dim Userid As String
    Dim Passwd As String
    Dim Domain As String
    Dim ADC As String
    
    Userid = "username"
    Passwd = "password"
    Domain = "XYZ"
    ADC = "adc-xyz-201.amer.xyz.com"
        
    lngRet = InvokeKCC(Userid, Passwd, Domain, ADC)
    
    LstOutput.AddItem " "
    
    If lngRet <> 0 Then
        LstOutput.AddItem "Error " & lngRet
    Else
        LstOutput.AddItem "Success!"
    End If

End Sub

Private Function InvokeKCC(strUserid As String, strPasswd As String, _
    StrDomain As String, StrDC As String) As Long

    Dim lRet As Long
    Dim hDS As Long
    Dim hCred As Long
    Dim strADC As String
    
    strADC = "\\" & StrDC & Chr(0)
    
    ' Create a credential handle
    lRet = DsMakePasswordCredentials(strUserid, _
           StrDomain, _
           strPasswd, _
           hCred)

    If lRet <> 0 Then
        LstOutput.AddItem "Error " & lRet & _
        " creating a credential handle for " & StrDomain & "\" & strUserid
        GoTo hError
    Else
        LstOutput.AddItem "Successfully created a credential handle for " & _
        StrDomain & "\" & strUserid
    End If
    
    ' Bind to a Domain Controller
    lRet = DsBindWithCred(strADC, _
           vbNullString, _
           hCred, _
           hDS)
    
    If lRet <> 0 Then
        LstOutput.AddItem "Error " & lRet & " binding to " & _
        StrDC & " with the credential handle"
        GoTo hError
    Else
        LstOutput.AddItem "Successfully bound to " & StrDC & _
        " with the credential handle"
    End If
    
    ' invoke the Knowledge Consistency Checker (KCC)
    ' to verify the replication topology
    lRet = DsReplicaConsistencyCheck(hDS, _
           DS_KCC_TASKID_UPDATE_TOPOLOGY, _
           DS_KCC_FLAG_ASYNC_OP)
    
     If lRet <> 0 Then
        LstOutput.AddItem "Error " & lRet & _
        " unable to invoke the KCC on " & StrDC
        GoTo hError
    Else
        LstOutput.AddItem "Successfully invoked the KCC on " & StrDC
    End If
    
    ' Free the passed in Credentials
    lRet = DsFreePasswordCredentials(hCred)
    
    If lRet <> 0 Then
        LstOutput.AddItem "Error " & lRet & _
        " freeing the credential handle"
        GoTo hError
    Else
        LstOutput.AddItem "Successfully freed the credential handle"
    End If
    
    ' Unbind from the server
    lRet = DsUnBind(hDS)
    
    If lRet <> 0 Then
        LstOutput.AddItem "Error " & _
        lRet & " unbinding from the Domain"
        GoTo hError
    Else
        LstOutput.AddItem "Successfully unbound from the Domain"
    End If
    
    GoTo hError
    
hError:
    
    InvokeKCC = lRet

End Function

Private Sub cmdCopy_Click()

    Dim i As Long
    Clipboard.Clear
    txtCopy.Text = ""
    For i = 0 To LstOutput.ListCount - 1
        txtCopy.Text = txtCopy.Text & LstOutput.List(i) & vbCrLf
    Next i
    Clipboard.SetText txtCopy
End Sub
