'# -----------------------------------------------------------------------------
'# From the book "Managing Enterprise Active Directory Services"
'# ISBN: 0-672-32125-4
'# Copyright (C) 2002 by Addison-Wesley
'# Script by Robbie Allen
'# 
'# You have a royalty-free right to use, modify, reproduce and distribute
'# this script (and/or any modified version) in any way you find useful,
'# provided that you agree that Addison-Wesley or Robbie Allen has no
'# warranty, obligations or liability for the script. If you modify
'# the script, you must retain this copyright notice.
'# -----------------------------------------------------------------------------
ON ERROR RESUME NEXT

Dim kcc_value, server, user, passwd, sites_dn
Dim filter, query, adoObj, resObj, count, site, siteADsPath
Dim ldapObj, ntdssiteObj

kcc_value = 17 ' Disable both intra and inter site topology generation

server = "dc1"
user   = "administrator@xyz.com"
passwd = "password"

' This could be dynamically retrieved using RootDSE
sites_dn = "cn=sites,cn=configuration,dc=xyz,dc=com"

filter = "(&(objectClass=ntdssitesettings)" _
       & "(objectCategory=ntdssitesettings))"
query = "<LDAP://" & server & "/" _
        &  sites_dn & ">;" & filter & ";distinguishedName;subtree"

' Set up the ADO query
Set adoObj = CreateObject("ADODB.Connection")
adoObj.Provider = "ADsDSOObject"
adoObj.Open "AD Provider", user, passwd
Set resObj  = adoObj.Execute(query)

Wscript.Echo "Setting the KCC value in all sites to kcc_value"
count = 0
resObj.MoveFirst
While Not resObj.EOF
    count = count + 1
    site = resObj.Fields(0).Value
    siteADsPath = "LDAP://" & server & "/" & site
    Wscript.Echo count & ". " & site

    Set ldapObj = GetObject("LDAP:")
    Set ntdssiteObj = ldapObj.OpenDsObject(siteADsPath, user, passwd,1)
    ntdssiteObj.Put "options", kcc_value
    ntdssiteObj.SetInfo
    If Err.Number then
       Wscript.Echo "   Error occured when setting KCC value: " _ 
                     & Err.Description
    Else
       Wscript.Echo "   Set KCC value"
    End If
   
    resObj.MoveNext
Wend
