# -----------------------------------------------------------------------------
# From the book "Managing Enterprise Active Directory Services"
# ISBN: 0-672-32125-4
# Copyright (C) 2002 by Addison-Wesley
# Script by Robbie Allen
# 
# You have a royalty-free right to use, modify, reproduce and distribute
# this script (and/or any modified version) in any way you find useful,
# provided that you agree that Addison-Wesley or Robbie Allen has no
# warranty, obligations or liability for the script. If you modify
# the script, you must retain this copyright notice.
# -----------------------------------------------------------------------------
use strict;
use Win32::OLE;

# DC and object information
my $dc = 'dc2';
my $dn = 'cn=janesmith,cn=users,dc=xyz,dc=com';

# Authentication information
my $user   = 'administrator';
my $passwd = 'password';
my $domain = 'XYZ';

my $i = Win32::OLE->new("IADsTools.DCFunctions");
my $res = $i->SetUserCredentials($user,$domain,"",$passwd);
die "Authentication failed in SetUserCredentials\n" if $res != 0;

my $res = $i->GetMetaData($dc,$dn,1);
if ($res < 1) {
   print "Could not get metadata for $dn on $dc\n";
}
else {
   print "$dn has $res attributes in metadata\n";
   for my $c(1..$res) {
      print $i->MetaDataName($c),"\n";
      print "\tLast write: ",$i->MetaDataLastWriteTime($c),"\n";
      print "\tLocal USN: ",$i->MetaDataLocalUSN($c),"\n";
      print "\tSource Server: ",$i->MetaDataServerName($c),"\n";
      print "\tSource USN: ",$i->MetaDataSourceUSN($c),"\n";
      print "\tVersion: ",$i->MetaDataVersionNumber($c),"\n";
   }
}
