# -----------------------------------------------------------------------------
# From the book "Managing Enterprise Active Directory Services"
# ISBN: 0-672-32125-4
# Copyright (C) 2002 by Addison-Wesley
# Script by Robbie Allen
# 
# You have a royalty-free right to use, modify, reproduce and distribute
# this script (and/or any modified version) in any way you find useful,
# provided that you agree that Addison-Wesley or Robbie Allen has no
# warranty, obligations or liability for the script. If you modify
# the script, you must retain this copyright notice.
# -----------------------------------------------------------------------------
use strict;
use Win32::OLE;

# DCs to sync
my $target_dc1 = 'dc1';
my $source_dc2 = 'dc2';
my $nc         = 'cn=configuration,dc=xyz,dc=com';

# Authentication information
my $user   = 'administrator';
my $passwd = 'password';
my $domain = 'XYZ';

my $i = Win32::OLE->new("IADsTools.DCFunctions");
my $res = $i->SetUserCredentials($user,$domain,"",$passwd);
die "Authentication failed in SetUserCredentials\n" if $res != 0;

my $res = $i->ReplicaSync($target_dc1,$nc,$source_dc2,0,1);
if ($res != 0) {
   print "Sync unsuccessful between $target_dc1 and $source_dc2\n";
}
else {
   print "Sync successful between $target_dc1 and $source_dc2\n";
}
