# -----------------------------------------------------------------------------
# From the book "Managing Enterprise Active Directory Services"
# ISBN: 0-672-32125-4
# Copyright (C) 2002 by Addison-Wesley
# Script by Robbie Allen
# 
# You have a royalty-free right to use, modify, reproduce and distribute
# this script (and/or any modified version) in any way you find useful,
# provided that you agree that Addison-Wesley or Robbie Allen has no
# warranty, obligations or liability for the script. If you modify
# the script, you must retain this copyright notice.
# -----------------------------------------------------------------------------
use strict;
use Win32::OLE;

# DC to query
my $dc = 'dc1';
my $nc = 'dc=xyz,dc=com';

# Authentication information
my $user   = 'administrator';
my $passwd = 'password';
my $domain = 'XYZ';

my $i = Win32::OLE->new("IADsTools.DCFunctions");
my $res = $i->SetUserCredentials($user,$domain,"",$passwd);
die "Authentication failed in SetUserCredentials\n" if $res != 0;

my $res = $i->GetDirectPartners($dc,$nc,0,1);
if ($res < 1) {
   print "Could not get replication partners for $dc\n";
}
else {
   print "$dc has $res partner(s) for $nc:\n";
   for my $c(1..$res) {
      print $i->DirectPartnerName($c),"\n";
      print "\tPartner GUID: ",$i->DirectPartnerGuid($c),"\n";
      print "\tTransport: ",$i->DirectPartnerTransportDN($c),"\n";
      print "\tFail Reason: ",$i->DirectPartnerFailReason($c),"\n";
      print "\tIn Conflict: ",$i->DirectPartnerInConflict($c),"\n";
      print "\tNum Failures: ",$i->DirectPartnerNumberFailures($c),"\n";
      print "\tHigh OU: ",$i->DirectPartnerHighOU($c),"\n";
      print "\tHigh PU: ",$i->DirectPartnerHighPU($c),"\n";
      print "\tLast Success: ",$i->DirectPartnerLastSuccessTime($c),"\n";
      print "\tLast Attempt: ",$i->DirectPartnerLastAttemptTime($c),"\n";
   }
}
