'# -----------------------------------------------------------------------------
'# From the book "Managing Enterprise Active Directory Services"
'# ISBN: 0-672-32125-4
'# Copyright (C) 2002 by Addison-Wesley
'# Script by Robbie Allen
'# 
'# You have a royalty-free right to use, modify, reproduce and distribute
'# this script (and/or any modified version) in any way you find useful,
'# provided that you agree that Addison-Wesley or Robbie Allen has no
'# warranty, obligations or liability for the script. If you modify
'# the script, you must retain this copyright notice.
'# -----------------------------------------------------------------------------
Dim server, user, passwd
server = "dc2"
user = "administrator@xyz.com"
passwd = "password"

' Update the becomeSchemaMaster operational attribute
' Note that in this case, an authenticated RootDSE session must be established
Dim ldapObj, rootDSEObjW
Set ldapObj = GetObject("LDAP:")
Set rootDSEObjW = ldapObj.OpenDsObject(rootDSEObj.ADsPath,user,passwd,1)
rootDSEObjW.Put "becomeSchemaMaster", server
rootDSEObjW.SetInfo

' Get the schema container DN
Dim rootDSEObj, query
Set rootDSEObj = GetObject("LDAP://" & server & "/RootDSE")
query = "<LDAP://" & server & "/" _
              & rootDSEObj.Get("schemaNamingContext") _
            & ">;(&(objectClass=dMD)(fSMORoleOwner=*));fSMORoleOwner;subtree"

' Set up the ADO query
Dim adoObj
Set adoObj = CreateObject("ADODB.Connection")
adoObj.Provider = "ADsDSOObject"
adoObj.Open "AD Provider", user, passwd

' Execute the query and get the object referenced in fSMORoleOwner
Dim resObj, fsmoNTDSDN, fsmoNTDSObj
Set resObj  = adoObj.Execute(query)
fsmoNTDSDN = "LDAP://" & server & "/" & resObj.Fields(0).Value
Set fsmoNTDSObj = ldapObj.OpenDsObject(fsmoNTDSDN,user,passwd,1)

' Get the parent of that object which will have the dNSHostName attribute
' of the Schema FSMO
Dim fsmoObj
Set fsmoObj = ldapObj.OpenDsObject(fsmoNTDSObj.Parent,user,passwd,1)
WScript.Echo fsmoObj.dnsHostName
