# -----------------------------------------------------------------------------
# From the book "Managing Enterprise Active Directory Services"
# ISBN: 0-672-32125-4
# Copyright (C) 2002 by Addison-Wesley
# Script by Robbie Allen
# 
# You have a royalty-free right to use, modify, reproduce and distribute
# this script (and/or any modified version) in any way you find useful,
# provided that you agree that Addison-Wesley or Robbie Allen has no
# warranty, obligations or liability for the script. If you modify
# the script, you must retain this copyright notice.
# -----------------------------------------------------------------------------
use strict;
use Win32::TieRegistry(Delimiter=>"/");
use Win32::NetResource;

my $server = 'dc1';
my $user   = 'XYZ\administrator';
my $passwd = 'password';
my $key    = "System/CurrentControlSet/Services/NTDS/";
   $key   .= "Parameters/Schema Update Allowed";
my $value  = '0x00000001';

# Create an IPC connection to $server
my %conn_info = (Type => RESOURCETYPE_ANY, RemoteName => "\\\\$server\\IPC\$");
Win32::NetResource::AddConnection(\%conn_info, $passwd, $user, 0)
      or die "Could not add connection: $^E\n";

my $regObj = $Registry->{"//$server/LMachine"} 
          or die "Could not connect $^E";

if ($regObj->{$key} eq $value) {
   print "Key already set: ",$regObj->{$key},"\n";
}
else {
   print "Setting key...";
   $regObj->{$key} = [ $value, REG_DWORD ] 
                     or die "Could not modify registry: $^E";
   print "done\n";
}

# Close IPC connection
Win32::NetResource::CancelConnection("\\\\$server", 0, 0)
           or die "Could not cancel IPC connection: $^E\n";
