# -----------------------------------------------------------------------------
# From the book "Managing Enterprise Active Directory Services"
# ISBN: 0-672-32125-4
# Copyright (C) 2002 by Addison-Wesley
# Script by Robbie Allen
# 
# You have a royalty-free right to use, modify, reproduce and distribute
# this script (and/or any modified version) in any way you find useful,
# provided that you agree that Addison-Wesley or Robbie Allen has no
# warranty, obligations or liability for the script. If you modify
# the script, you must retain this copyright notice.
# -----------------------------------------------------------------------------
use strict;
use Net::LDAP;
use Net::LDAP::Entry;

my $server  = 'dc1';
my $user    = 'administrator@xyz.com';
my $passwd  = 'password';

my $new_user = 'user1';

my $ldap = Net::LDAP->new($server)
           or die "Could not connect to $server: $@";

my $bind = $ldap->bind($user, password => $passwd);
die "Could not bind to server: ", $bind->error if $bind->code;

my $usrObj = Net::LDAP::Entry->new();
$usrObj->dn("cn=$new_user,cn=Users,dc=xyz,dc=com");
$usrObj->add(objectclass     => 'user',
             sAMAccountName  => $new_user,
           );
my $result = $usrObj->update($ldap);
if ($result->code) {
   print "Error occurred creating user: ",$result->error,"\n";
}
else {
   print "User created\n";
}
