'# -----------------------------------------------------------------------------
'# From the book "Managing Enterprise Active Directory Services"
'# ISBN: 0-672-32125-4
'# Copyright (C) 2002 by Addison-Wesley
'# Script by Robbie Allen
'# 
'# You have a royalty-free right to use, modify, reproduce and distribute
'# this script (and/or any modified version) in any way you find useful,
'# provided that you agree that Addison-Wesley or Robbie Allen has no
'# warranty, obligations or liability for the script. If you modify
'# the script, you must retain this copyright notice.
'# -----------------------------------------------------------------------------
ON ERROR RESUME NEXT

new_user = "janesmith"

Dim strUser, strPasswd, new_user
strUser   = "administrator@xyz.com"
strPasswd = "password"

Dim ldapObj, contADsPath, contObj
Set ldapObj = GetObject("LDAP:")
contADsPath = "LDAP://cn=Users,dc=xyz,dc=com"
Set contObj = ldapObj.OpenDsObject(contADsPath,strUser,strPasswd,1)

Set usrObj = contObj.Create("user","cn=" & new_user)

usrObj.Put "sAMAccountName",new_user
usrObj.Put "userPrincipalName", new_user & "@xyz.com"
usrObj.Put "mail", new_user & "@xyz.com"
usrObj.Put "givenName", "Jane"
usrObj.Put "sn", "Smith"
usrObj.Put "displayName", "Jane Smith"
usrObj.Put "manager", "cn=jimsmith,cn=Users,dc=xyz,dc=com"
usrObj.Put "title", "Programmer"
usrObj.Put "department", "IT"
usrObj.Put "description", "User account for " & new_user
usrObj.Put "employeeID", "1234"
usrObj.Put "telephoneNumber", "911-555-1234"
usrObj.SetInfo
If Err.Number Then
   Wscript.Echo "Error occurred creating user: " & Err.Description
   Wscript.Quit
Else
   Wscript.Echo "User created"
End If

' Set password equal to username
usrObj.SetPassword( new_user )
If Err.Number Then
   Wscript.Echo "Error occurred setting password: " & Err.Description
   Wscript.Quit
Else
   Wscript.Echo "Set password"
End If

usrObj.Put "pwdLastSet", 0
usrObj.SetInfo
If Err.Number Then
   Wscript.Echo "Error occurred setting password change: " & Err.Description
   Wscript.Quit
Else
   Wscript.Echo "Account must change password at next logon"
End If

' Enable account
usrObj.AccountDisabled = FALSE
usrObj.SetInfo
If Err.Number Then
   Wscript.Echo "Error occurred enabling account: " & Err.Description
   Wscript.Quit
Else
   Wscript.Echo "Enabled account"
End If
