# -----------------------------------------------------------------------------
# From the book "Managing Enterprise Active Directory Services"
# ISBN: 0-672-32125-4
# Copyright (C) 2002 by Addison-Wesley
# Script by Robbie Allen
# 
# You have a royalty-free right to use, modify, reproduce and distribute
# this script (and/or any modified version) in any way you find useful,
# provided that you agree that Addison-Wesley or Robbie Allen has no
# warranty, obligations or liability for the script. If you modify
# the script, you must retain this copyright notice.
# -----------------------------------------------------------------------------
use strict;
use Net::LDAP;

my $server  = 'dc1';
my $user    = 'administrator@xyz.com';
my $passwd  = 'password';

sub UF_LOCKOUT { 16 }

my $ldap = Net::LDAP->new($server)
           or die "Could not connect to server: $@";

my $bind = $ldap->bind($user, password => $passwd);
die "Could not bind to server: ", $bind->error if $bind->code;

my $username = 'administrator';
my $result = $ldap->search(base => "cn=Users,dc=xyz,dc=com",
                           scope => 'subtree',
                           filter => "(&(objectclass=user)(cn=$username))");
my ($entry) = $result->entries;
my $uac = $entry->get_value('userAccountControl');
if ($uac & &UF_LOCKOUT) {
   print "Account is locked\n";
   $entry->replace(userAccountControl => $uac | &UF_LOCKOUT);
   $entry->update( $ldap );
   print "Unlocked account\n";
}
else {
   print "Account is NOT locked\n";
}
