# -----------------------------------------------------------------------------
# From the book "Managing Enterprise Active Directory Services"
# ISBN: 0-672-32125-4
# Copyright (C) 2002 by Addison-Wesley
# Script by Robbie Allen
# 
# You have a royalty-free right to use, modify, reproduce and distribute
# this script (and/or any modified version) in any way you find useful,
# provided that you agree that Addison-Wesley or Robbie Allen has no
# warranty, obligations or liability for the script. If you modify
# the script, you must retain this copyright notice.
# -----------------------------------------------------------------------------
use strict;
use Net::LDAP;

my $server  = 'dc1';
my $user    = 'administrator@xyz.com';
my $passwd  = 'password';

my $ldap = Net::LDAP->new($server)
           or die "Could not connect to server: $@";

my $bind = $ldap->bind(dn => $user, password => $passwd);
die "Could not bind to server: ", $bind->error if $bind->code;

my $result = $ldap->search(base=>"cn=Administrators,cn=Builtin,dc=xyz,dc=com",
                           scope=>'onelevel',
                           filter=>'(&(objectclass=group)
                                      (objectcategory=group))');
die "Could not find group : ", $result->error if $result->code;

my ($grpObj) = $result->entries;
print "Members of Administrators group:\n";
foreach ( $grpObj->get_value('member') ) {
   print "\t$_\n";
}
