'# -----------------------------------------------------------------------------
'# From the book "Managing Enterprise Active Directory Services"
'# ISBN: 0-672-32125-4
'# Copyright (C) 2002 by Addison-Wesley
'# Script by Robbie Allen
'# 
'# You have a royalty-free right to use, modify, reproduce and distribute
'# this script (and/or any modified version) in any way you find useful,
'# provided that you agree that Addison-Wesley or Robbie Allen has no
'# warranty, obligations or liability for the script. If you modify
'# the script, you must retain this copyright notice.
'# -----------------------------------------------------------------------------
ON ERROR RESUME NEXT

Dim server, user, passwd
server  = "jdoe-pc1"
user    = "XYZ\administrator"
passwd  = "password"

Dim locatorObj, serverObj
'Create Locator object to connect to remote CIM object manager
set locatorObj = CreateObject("WbemScripting.SWbemLocator")

'Connect to the CIMv2 namespace
set serverObj = locatorObj.ConnectServer (server, "root\cimv2",user, passwd)
If Err.Number then
    Wscript.Echo( "Error connecting to server: " & Err.Description)
    Wscript.Quit
End If

' Get logical drive information
Wscript.Echo "Drive information:"
Wscript.Echo "------------------"
Wscript.Echo "   Total    Free"
Dim query, enumeratorObj, instanceObj, drive, totalspace, freespace
query = "Select FreeSpace, Size, DeviceID From Win32_LogicalDisk"
set enumeratorObj = serverObj.ExecQuery(query,,0)
If Err.Number Then
   Wscript.Echo "Error performing query: " & Err.Description
   Wscript.Quit
End If

'Iterate over each drive
For Each instanceObj in enumeratorObj
   If Not (instanceObj is nothing) Then
       drive      = ""
       totalspace = ""
       freespace  = ""
       drive = instanceObj.DeviceID
       if instanceObj.Size Then
          totalspace = Round(instanceObj.Size/1048576) & " MB"
          freespace  = Round(instanceObj.FreeSpace/1048576) & " MB"
       End If
       Wscript.Echo  drive & " " & totalspace & "  " & freespace
   Else
       Wscript.Echo "Not available"
   End If
Next

'Get the logical memory configuration
Wscript.Echo ""
Wscript.Echo "Memory information:"
Wscript.Echo "-------------------"
Dim memObj
set memObj = serverObj.Get("Win32_LogicalMemoryConfiguration=""" _
             & "LogicalMemoryConfiguration""")
If Err.Number Then
   Wscript.Echo "Error getting memory information: " & Err.Description
   Wscript.Quit
End If
Wscript.Echo "Memory: " & Round(memObj.TotalPhysicalMemory/1024) & " MB"
Wscript.Echo "Virtual memory: " & Round(memObj.TotalVirtualMemory/1024) & " MB"

' Get CPU information
Wscript.Echo ""
Wscript.Echo "CPU information:"
Wscript.Echo "----------------"
Dim cpuSetObj,cpuObj
set cpuSetObj = serverObj.InstancesOf("Win32_Processor")
If Err.Number Then
   Wscript.Echo "Error getting CPU information: " & Err.Description
   Wscript.Quit
End If

If cpuSetObj.Count = 0 Then
   Wscript.Echo "No CPU information available"
End If

For Each cpuObj In cpuSetObj
   Wscript.Echo cpuObj.Name & " " & cpuObj.DeviceID & _
                " " & cpuObj.CurrentClockSpeed & " MHz"
Next
