# -----------------------------------------------------------------------------
# From the book "Managing Enterprise Active Directory Services"
# ISBN: 0-672-32125-4
# Copyright (C) 2002 by Addison-Wesley
# Script by Robbie Allen
# 
# You have a royalty-free right to use, modify, reproduce and distribute
# this script (and/or any modified version) in any way you find useful,
# provided that you agree that Addison-Wesley or Robbie Allen has no
# warranty, obligations or liability for the script. If you modify
# the script, you must retain this copyright notice.
# -----------------------------------------------------------------------------
use strict;
use Net::LDAP;
use Net::LDAP::Entry;

my $server  = 'dc1';
my $user    = 'administrator@xyz.com';
my $passwd  = 'password';
my $ldap = Net::LDAP->new($server)
           or die "Could not connect to $server: $@";
my $bind = $ldap->bind($user, password => $passwd);
die "Could not bind to server: ", $bind->error if $bind->code;

my $printername = "bldg2-floor1-printer";
my $printserver = "print-bldg2";
my $printObj = Net::LDAP::Entry->new();
$printObj->dn("cn=$printername,OU=Printers,dc=xyz,dc=com");
$printObj->add(objectclass     => 'printQueue',
               serverName      => $printserver,
               shortServerName => $printserver,
               printerName     => $printername,
               uNCName         => "\\\\$printserver\\$printername",
               versionNumber   => 1,
           );
my $result = $printObj->update($ldap);
if ($result->code) {
   print "Error occurred creating printer: ",$result->error,"\n";
}
else {
   print "Printer created\n";
}
