
# -----------------------------------------------------------------------------
# From the book "Managing Enterprise Active Directory Services"
# ISBN: 0-672-32125-4
# Copyright (C) 2002 by Addison-Wesley
# Code by Richard Puckett
#
# You have a royalty-free right to use, modify, reproduce and distribute
# this code (and/or any modified version) in any way you find useful,
# with the agreement that Richard Puckett or Addison-Wesley provide no
# warranty, obligations or liability for this code. If you reuse or
# modify this code, you must retain this copyright notice.
# -----------------------------------------------------------------------------
	
#! c:\perl\bin\perl.exe -w

use strict; 
use Win32::OLE qw(in); 

my $EvtCode  = shift || "529";
my $logFile  = shift || "Security";
my $Computer = shift || Win32::NodeName;

print "Checking the $logFile Event log on $Computer...\n\n";

my $EvtQuery = "SELECT * FROM Win32_NTLogEvent WHERE Logfile = '$logFile' AND EventCode = $EvtCode";

my $Wmi = Win32::OLE->GetObject("WinMgmts:{impersonationLevel=impersonate,(security)}!//$Computer") || die Win32::OLE->LastError;
my $Events = $Wmi->ExecQuery($EvtQuery) || die Win32::OLE->LastError;

foreach my $Event(in $Events) {
	print "-" x 45; 
	print "\n";
	print "       EventCode: ".$Event->{EventCode}."\n";
	print "        Category: ".$Event->{Category}."\n";
	print "  CategoryString: ".$Event->{CategoryString}."\n";
	print "    ComputerName: ".$Event->{ComputerName}."\n";
	print " EventIdentifier: ".$Event->{EventIdentifier}."\n";
	print "InsertionStrings: ".$Event->{InsertionStrings}."\n";
	print "         Logfile: ".$Event->{Logfile}."\n";
	print "    RecordNumber: ".$Event->{RecordNumber}."\n";
	print "      SourceName: ".$Event->{SourceName}."\n";
	print "   TimeGenerated: ".$Event->{TimeGenerated}."\n";
	print "     TimeWritten: ".$Event->{TimeWritten}."\n";
	print "            Type: ".$Event->{Type}."\n";
	print "            User: ".$Event->{User}."\n";
}


