
' -----------------------------------------------------------------------------
' From the book "Managing Enterprise Active Directory Services"
' ISBN: 0-672-32125-4
' Copyright (C) 2002 by Addison-Wesley
' Code by Richard Puckett
'
' You have a royalty-free right to use, modify, reproduce and distribute
' this code (and/or any modified version) in any way you find useful,
' with the agreement that Richard Puckett or Addison-Wesley provide no
' warranty, obligations or liability for this code. If you reuse or
' modify this code, you must retain this copyright notice.
' -----------------------------------------------------------------------------

Dim EventSet, LogEvent

Set EventSet = GetObject("winmgmts:{impersonationLevel=impersonate,(security)}"). _
	ExecQuery("SELECT * FROM Win32_NTLogEvent WHERE Logfile = 'Security' AND EventCode=529")

if (EventSet.Count = 0) then WScript.Echo "No Events Were Found."

for each LogEvent in EventSet
	WScript.Echo "       EventCode: " & LogEvent.EventCode
	WScript.Echo "        Category: " & LogEvent.Category
	WScript.Echo "  CategoryString: " & LogEvent.CategoryString
	WScript.Echo "    ComputerName: " & LogEvent.ComputerName
	WScript.Echo " EventIdentifier: " & LogEvent.EventIdentifier
	WScript.Echo "         Logfile: " & LogEvent.Logfile
	WScript.Echo "    RecordNumber: " & LogEvent.RecordNumber
	WScript.Echo "      SourceName: " & LogEvent.SourceName
	WScript.Echo "   TimeGenerated: " & WMItoVBTime(LogEvent.TimeGenerated)
	WScript.Echo "     TimeWritten: " & WMItoVBTime(LogEvent.TimeWritten)
	WScript.Echo "            Type: " & LogEvent.Type
	WScript.Echo "            User: " & LogEvent.User
	WScript.Echo "_______________________________________________"
next

Private Function WMItoVBTime(sDMTF)

	Dim sYear, sMonth, sDate, sHour, sMin, sSec

	sYear  = Mid(sDMTF, 1,4)
	sMonth = Mid(sDMTF, 5,2)
	sDate  = Mid(sDMTF, 7,2)
	sHour  = Mid(sDMTF, 9,2)
	sMin   = Mid(sDMTF,11,2)
	sSec   = Mid(sDMTF,13,2)

	WMItoVBTime = DateSerial (sYear, sMonth, sDate) _
				  & " " &  TimeSerial (sHour, sMin, sSec)

End Function

