
# -----------------------------------------------------------------------------
# From the book "Managing Enterprise Active Directory Services"
# ISBN: 0-672-32125-4
# Copyright (C) 2002 by Addison-Wesley
# Code by Richard Puckett
#
# You have a royalty-free right to use, modify, reproduce and distribute
# this code (and/or any modified version) in any way you find useful,
# with the agreement that Richard Puckett or Addison-Wesley provide no
# warranty, obligations or liability for this code. If you reuse or
# modify this code, you must retain this copyright notice.
# -----------------------------------------------------------------------------
	
#! c:\perl\bin\perl.exe -w

use strict;
use Win32;
use Win32::OLE qw(in);
use Mail::Sender;

my $Computer = Win32::NodeName;
my $evtQuery = "SELECT * FROM __instancecreationevent WHERE targetinstance ISA 'Win32_NTLogEvent' AND targetinstance.Logfile='Security'";

my $Events = Win32::OLE->GetObject("WinMgmts:{impersonationLevel=impersonate,(security)}")->
				 ExecNotificationQuery($evtQuery)	|| die Win32::OLE->LastError;

print "Polling for new Security Events...\n";

while (my $Event = $Events->NextEvent) {
	print "-" x 75; 
	print "\n";
	
	my $EvtID = $Event->TargetInstance->{EventCode};
	print "       EventCode: ".$EvtID."\n";
	print "        Category: ".$Event->TargetInstance->{Category}."\n";
	print "  CategoryString: ".$Event->TargetInstance->{CategoryString}."\n";
	print "    ComputerName: ".$Event->TargetInstance->{ComputerName}."\n";
	print " EventIdentifier: ".$Event->TargetInstance->{EventIdentifier}."\n";
	print "InsertionStrings: ".$Event->TargetInstance->{InsertionStrings}."\n";
	print "         Logfile: ".$Event->TargetInstance->{Logfile}."\n";
	print "    RecordNumber: ".$Event->TargetInstance->{RecordNumber}."\n";
	print "      SourceName: ".$Event->TargetInstance->{SourceName}."\n";
	print "   TimeGenerated: ".$Event->TargetInstance->{TimeGenerated}."\n";
	print "     TimeWritten: ".$Event->TargetInstance->{TimeWritten}."\n";
	print "            Type: ".$Event->TargetInstance->{Type}."\n";
	print "            User: ".$Event->TargetInstance->{User}."\n";
	print "-" x 75; 
	print "\n";

	# Send off an e-mail about the captured event...
	my $DateTime = scalar(localtime());
	e_mail("administrator\@xyz.com", 
	       "Event $EvtID was generated on $Computer on $DateTime", 
			 $Event->TargetInstance->{Message});
	
	print "Polling for new Security Events...\n";

}

# send an e-mail warning 
#---------------------------------------------------------
sub e_mail{
#---------------------------------------------------------
	my $recipient = shift;
	my $subject   = shift;
	my $msgbody   = shift;
	
	my $Sender = new Mail::Sender{from => "event-watch\@xyz.com", 
	             smtp => "smtp_mail_server"} 
					 || die " - Error $^E: Unable to send message!\n";
	$Sender->Open({to => "$recipient", subject => "$subject", cc => ""}); 
	$Sender->Send("$msgbody");
	$Sender->Close;
}