     
# -----------------------------------------------------------------------------
# From the book "Managing Enterprise Active Directory Services"
# ISBN: 0-672-32125-4
# Copyright (C) 2002 by Addison-Wesley
# Code by Richard Puckett
#
# You have a royalty-free right to use, modify, reproduce and distribute
# this code (and/or any modified version) in any way you find useful,
# with the agreement that Richard Puckett or Addison-Wesley provide no
# warranty, obligations or liability for this code. If you reuse or
# modify this code, you must retain this copyright notice.
# -----------------------------------------------------------------------------	

#! c:\perl\bin\perl.exe -w

use strict;
use Win32;
use Win32::API;
use Win32::OLE 'in';
use Win32::OLE::Const 'Active DS Type Library';

use constant SDDL_REVISION_1  => 0x1;
use constant DWORD => pack 'L', 0;
my $strSDDL = "\x00" x 1024;
my $ptr_strSDDL = DWORD;

my $Userid =  shift || "administrator\@xyz.com";
my $Passwd =  shift || "password";
my $AdsPath = shift || "LDAP://ou=xyz users,dc=xyz,dc=com";

my $ConvertSDToString = new Win32::API
	('ADVAPI32', 
	'ConvertSecurityDescriptorToStringSecurityDescriptor',
	['P', 'N', 'N', 'P', 'N'], 'N'
	);

print "Checking $AdsPath...\n";

my $DSO = Win32::OLE->GetObject("LDAP:")
	|| die "Unable to retrieve the LDAP Provider, Error: "
	.Win32::OLE->LastError()."\n";

my $DSBind = $DSO->OpenDSObject($AdsPath, 
	$Userid, 
	$Passwd, 
	ADS_SECURE_AUTHENTICATION)
	|| die "Unable to open $AdsPath, Error: "
	.Win32::OLE->LastError()."\n";

$DSBind->GetInfo; 

my $bSD = ($DSBind->Item('ntSecurityDescriptor')->
	Values)->[0]->GetObjectProperty(8);

my $ObjSD = $ConvertSDToString->Call($bSD, 
	SDDL_REVISION_1, 
	0xF, 
	$ptr_strSDDL, 
	NULL) 
	|| die "Could not retrieve the Security Descriptor, Error: "
	.Win32::OLE->LastError()."\n";

$strSDDL = unpack 'p', $ptr_strSDDL;

print "$strSDDL\n";

exit;


