    
# -----------------------------------------------------------------------------
# From the book "Managing Enterprise Active Directory Services"
# ISBN: 0-672-32125-4
# Copyright (C) 2002 by Addison-Wesley
# Code by Richard Puckett
#
# You have a royalty-free right to use, modify, reproduce and distribute
# this code (and/or any modified version) in any way you find useful,
# with the agreement that Richard Puckett or Addison-Wesley provide no
# warranty, obligations or liability for this code. If you reuse or
# modify this code, you must retain this copyright notice.
# -----------------------------------------------------------------------------
        
#! c:\perl\bin\perl.exe -w
    
my $SDDLVal = uc shift;

if (!defined $SDDLVal) {
	print "please supply a value to enumerate\n";
	exit;
}

my %SDDLHash = (  
	#dacl_flags 
	'P'=>'DACL/SACL Protected (DACL FLAG)', 
	'AR'=>'Auto-Inherit Requested (DACL FLAG)', 
	'AI'=>'DACL/DACL is Auto-Inherited (DACL FLAG)', 
	#ace_type
	'A'=>'Access Allowed  (ACE TYPE)',
	'D'=>'Access Denied (ACE TYPE)',
	'OA'=>'Object Access Allowed (ACE TYPE)',
	'OD'=>'Object Access Denied (ACE TYPE)',
	'AU'=>'Audit (ACE TYPE)',
	'AL'=>'Alarm (ACE TYPE)',
	'OU'=>'Object Audit (ACE TYPE)',
	'OL'=>'Object Alarm (ACE TYPE)',
	#ace_flag 
	'CI'=>'Container Inherit (ACE FLAG)',
	'OI'=>'Object Inherit (ACE FLAG)',
	'NP'=>'Inherit (No Propogate) (ACE FLAG)',
	'IO'=>'Inherit Only (ACE FLAG)',
	'ID'=>'Inherited (ACE FLAG)',
	'SA'=>'Audit Success (ACE FLAG)',
	'FA'=>'Audit Failure (ACE FLAG)',
	#generic_access_rights 
	'GA'=>'GENERIC_ALL (GENERIC ACCESS RIGHT)',
	'GR'=>'GENERIC_READ (GENERIC ACCESS RIGHT)',
	'GW'=>'GENERIC_WRITE (GENERIC ACCESS RIGHT)',
	'GX'=>'GENERIC_EXECUTE (GENERIC ACCESS RIGHT)',	 
	#standard_access_rights 
	'RC'=>'READ_CONTROL (STANDARD ACCESS RIGHT)',
	'SD'=>'DELETE (STANDARD ACCESS RIGHT)', 
	'WD'=>'WRITE_DAC (STANDARD ACCESS RIGHT)',
	'WO'=>'WRITE_OWNER (STANDARD ACCESS RIGHT)',
	#ds_object_access_rights 
	'RP'=>'ADS_RIGHT_DS_READ_PROP (DS OBJECT ACCESS RIGHT)',
	'WP'=>'ADS_RIGHT_DS_WRITE_PROP (DS OBJECT ACCESS RIGHT)',
	'CC'=>'ADS_RIGHT_DS_CREATE_CHILD (DS OBJECT ACCESS RIGHT)',
	'DC'=>'ADS_RIGHT_DS_DELETE_CHILD (DS OBJECT ACCESS RIGHT)',
	'LC'=>'ADS_RIGHT_DS_LIST (DS OBJECT ACCESS RIGHT)',
	'SW'=>'ADS_RIGHT_DS_SELF (DS OBJECT ACCESS RIGHT)',
	'LO'=>'ADS_RIGHT_DS_LIST_OBJECT (DS OBJECT ACCESS RIGHT)', 
	'DT'=>'ADS_RIGHT_DS_DELETE_TREE (DS OBJECT ACCESS RIGHT)',
	'CR'=>'ADS_RIGHT_DS_CONTROL_ACCESS (DS OBJECT ACCESS RIGHT)',
	#file_access_rights 
	'FA'=>'FILE_ALL_ACCESS (FILE ACCESS RIGHT)',
	'FR'=>'FILE_GENERIC_READ (FILE ACCESS RIGHT)', 
	'FW'=>'FILE_GENERIC_WRITE (FILE ACCESS RIGHT)', 
	'FX'=>'FILE_GENERIC_EXECUTE (FILE ACCESS RIGHT)', 
	#registry_key_access_rights 
	'KA'=>'KEY_ALL_ACCESS (REGISTRY KEY ACCESS RIGHT)',
	'KR'=>'KEY_READ (REGISTRY KEY ACCESS RIGHT)', 
	'KW'=>'KEY_WRITE (REGISTRY KEY ACCESS RIGHT)', 
	'KX'=>'KEY_EXECUTE (REGISTRY KEY ACCESS RIGHT)', 
	#account_alias
	'AO'=>'Account operators (ACCOUNT ALIAS)', 
	'RU'=>'Pre-Windows 2000 Compatible Accesss (ACCOUNT ALIAS)',  
	'AN'=>'Anonymouss (ACCOUNT ALIAS)',  
	'AU'=>'Authenticated Users (ACCOUNT ALIAS)',  
	'BA'=>'Administrators (ACCOUNT ALIAS)',  
	'BG'=>'Guests (ACCOUNT ALIAS)',  
	'BO'=>'Backup Operators (ACCOUNT ALIAS)',  
	'BU'=>'Users (ACCOUNT ALIAS)',  
	'CA'=>'Certificate Server Administrators (ACCOUNT ALIAS)',  
	'CG'=>'Creator (Group) (ACCOUNT ALIAS)',  
	'CO'=>'CREATOR/OWNER (ACCOUNT ALIAS)',  
	'DA'=>'Domain Admins (ACCOUNT ALIAS)',  
	'DC'=>'Domain Computers (ACCOUNT ALIAS)',  
	'DD'=>'Domain Controllers (ACCOUNT ALIAS)',  
	'DG'=>'Domain Guests (ACCOUNT ALIAS)',  
	'DU'=>'Domain Users (ACCOUNT ALIAS)',  
	'EA'=>'Enterprise Administrators (ACCOUNT ALIAS)',  
	'ED'=>'Enterprise Domain Controllers (ACCOUNT ALIAS)',  
	'WD'=>'Everyone (ACCOUNT ALIAS)',  
	'PA'=>'Group Policy Administrators (ACCOUNT ALIAS)',  
	'IU'=>'INTERACTIVE (ACCOUNT ALIAS)',  
	'LA'=>'Administrator (ACCOUNT ALIAS)',  
	'LG'=>'Guest (ACCOUNT ALIAS)',  
	'LS'=>'Local Service Account (ACCOUNT ALIAS)',  
	'SY'=>'SYSTEM (ACCOUNT ALIAS)',  
	'NU'=>'Network Logon User (ACCOUNT ALIAS)',  
	'NO'=>'Network Configuration Operators (ACCOUNT ALIAS)',  
	'NS'=>'Network Service Account (ACCOUNT ALIAS)',  
	'PO'=>'Printer operators (ACCOUNT ALIAS)',  
	'PS'=>'SELF (ACCOUNT ALIAS)', 
	'PU'=>'Power Users (ACCOUNT ALIAS)',  
	'RS'=>'RAS Servers Group (ACCOUNT ALIAS)',  
	'RD'=>'Terminal Server Users (ACCOUNT ALIAS)',  
	'RE'=>'Replicator (ACCOUNT ALIAS)',  
	'RC'=>'Restricted Code (ACCOUNT ALIAS)',  
	'SA'=>'Schema Administrators (ACCOUNT ALIAS)',  
	'SO'=>'Server Operators (ACCOUNT ALIAS)',  
	'SU'=>'ervice Logon User (ACCOUNT ALIAS)', 
);

if (exists($SDDLHash{$SDDLVal})) {
	print "'".$SDDLVal."' is ".$SDDLHash{$SDDLVal}."\n";
} else {
	print "Unable to determine the value for '$SDDLVal'\n";
}
