
# -----------------------------------------------------------------------------
# From the book "Managing Enterprise Active Directory Services"
# ISBN: 0-672-32125-4
# Copyright (C) 2002 by Addison-Wesley
# Code by Richard Puckett
#
# You have a royalty-free right to use, modify, reproduce and distribute
# this code (and/or any modified version) in any way you find useful,
# with the agreement that Richard Puckett or Addison-Wesley provide no
# warranty, obligations or liability for this code. If you reuse or
# modify this code, you must retain this copyright notice.
# -----------------------------------------------------------------------------

#! c:\perl\bin\perl.exe -w

use strict;
use Data::Dumper;
use Win32::OLE 'in';
use Win32::OLE::Const 'Active DS Type Library';
$Win32::OLE::Warn = 3;

my @ExtRghts;
my $usr = "XYZ\\administrator";
my $pwd = "password";

my $RDSE = Win32::OLE->GetObject("LDAP://RootDSE") 
	|| die "Unable to retrieve RootDSE, Error: "
	.Win32::OLE->LastError()."\n";

my $RootDSE = $RDSE->Get("RootDomainNamingContext") 
	|| die "Unable to retrieve Root Domain name, Error: "
	.Win32::OLE->LastError()."\n";

my @ExtRghts = &get_rights_guid($usr, $pwd, $RootDSE);

foreach my $ExtRght (@ExtRghts) {
  print "Extended Right: $ExtRght->{cn}\n";
  print "DN: $ExtRght->{distinguishedName}\n";
  print "RightsGUID: $ExtRght->{rightsGuid}\n";
  print "\n";
}

exit;


# enumerate all extended rights in the config container
#---------------------------------------------------------
 sub get_rights_guid {
#---------------------------------------------------------
	
	my $userid = shift;
	my $passwd = shift;
 	my $rDSE = shift;	
	my @Rights;
  
	my $path = "LDAP://cn=Extended-Rights,CN=Configuration,$rDSE";
	my $query = "SELECT cn, rightsGuid, distinguishedName, objectGUID from '".$path."'";
	
	my $oCN = Win32::OLE->new('ADODB.Connection');
		$oCN->{Provider} = "ADsDSOObject";
		$oCN->Properties('User ID')->{Value} = $userid;
		$oCN->Properties('Password')->{Value} = $passwd;
		$oCN->Open;
	
	my $oRS = $oCN->Execute($query);

	while (!($oRS->EOF)){
		my %record;
		foreach my $field (in $oRS->Fields){
			$record{$field->Name} = $field->Value;
		}
	
		$oRS->MoveNext;
		push @Rights, \%record;
	}

	return @Rights;

}
