
# -----------------------------------------------------------------------------
# From the book "Managing Enterprise Active Directory Services"
# ISBN: 0-672-32125-4
# Copyright (C) 2002 by Addison-Wesley
# Code by Richard Puckett
#
# You have a royalty-free right to use, modify, reproduce and distribute
# this code (and/or any modified version) in any way you find useful,
# with the agreement that Richard Puckett or Addison-Wesley provide no
# warranty, obligations or liability for this code. If you reuse or
# modify this code, you must retain this copyright notice.
# -----------------------------------------------------------------------------
        
#! c:\perl\bin\perl.exe -w

use strict;
use Win32::API;
 
#DeleteGPOLink
#The DeleteGPOLink function deletes the link between the specified GPO and the specified site, domain, or organizational unit. 

#HRESULT DeleteGPOLink(
#  LPOLESTR lpGPO,
#  LPOLESTR lpContainer
#);

#Parameters
#lpGPO 
#[in] Specifies the path to the GPO, in ADSI format (LDAP://cn=user, ou=users, dc=coname, dc=com). You cannot specify a server name in this parameter. 
#lpContainer 
#[in] Specifies the Active Directory path to the site, domain, or organizational unit. 

my $DeleteLink = new Win32::API('GPEDIT', 
   'DeleteGPOLink', 
   ['P', 'P'], 'N');

my $gplink = "LDAP://OU=Employees,OU=XYZ Users,DC=xyz,DC=com"
my $gpo = "LDAP://CN=Machine,CN={31B2F340-016D-11D2-945F-00C04FB984F9},CN=Policies,CN=System,DC=xyz,DC=com"

my $lret = $DeleteLink->Call($gpo, $gplink) 
	or die "Error $^E: Could not delete the policy link for $gplink\n";


