
# -----------------------------------------------------------------------------
# From the book "Managing Enterprise Active Directory Services"
# ISBN: 0-672-32125-4
# Copyright (C) 2002 by Addison-Wesley
# Code by Richard Puckett
#
# You have a royalty-free right to use, modify, reproduce and distribute
# this code (and/or any modified version) in any way you find useful,
# with the agreement that Richard Puckett or Addison-Wesley provide no
# warranty, obligations or liability for this code. If you reuse or
# modify this code, you must retain this copyright notice.
# -----------------------------------------------------------------------------
        
#! c:\perl\bin\perl.exe -w

#HRESULT DeleteAllGPOLinks(
#  LPOLESTR lpContainer
#);

use strict;
use Win32::API;

my $DelAllPolLinks = new Win32::API('GPEDIT', 
   'DeleteAllGPOLinks', 
   ['P'], 'N');

my $gplink = "LDAP://OU=Employees,OU=XYZ Users,DC=xyz,DC=com"

# deletes all GPO links for the specified site, domain, or organizational unit
my $lret = $DelAllPolLinks->Call($gplink) 
	or die "Error $^E: Could not delete all policy links for $gplink\n";